/***************************************************************************
                          serial2view.cpp  -  description
                             -------------------
    begin                : Ut feb 18 14:21:20 CET 2003
    copyright            : (C) 2003 by Ondrej Krško
    email                : ondrej.krsko@zoznam.sk
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>

// application specific includes
#include "serial2view.h"
#include "serial2doc.h"
#include "serial2.h"

Serial2View::Serial2View(Serial2Doc* pDoc, QWidget *parent, const char *name) : QWidget(parent, name)
{
  setBackgroundMode(PaletteBase);
  mousePressed = false;
  doc = pDoc;
}

Serial2View::~Serial2View()
{
}

void Serial2View::mousePressEvent( QMouseEvent *e )
{
  mousePressed = true;
  oldX = e->x();
  oldY = e->y();
}
void Serial2View::mouseReleaseEvent( QMouseEvent *e )
{
  mousePressed = false;  
}

void Serial2View::mouseMoveEvent( QMouseEvent *e )
{
  if (mousePressed)
  {
    QPainter paint( &doc->buffer );
    paint.setPen( Qt::blue );
    paint.drawLine( oldX, oldY, e->x(), e->y() );
  
    QRect r = QRect(oldX-10, oldY-10, e->x()+10, e->y()+10);
    bitBlt( this, r.x(), r.y(), &doc->buffer, r.x(), r.y(),
       r.width(), r.height() );       
    oldX = e->x();
    oldY = e->y();    
    doc->setModified( true );
  }
}

void Serial2View::paintEvent ( QPaintEvent *e )
{
  QWidget::paintEvent( e );
  QRect r = e->rect();
  bitBlt( this, r.x(), r.y(), &doc->buffer, r.x(), r.y(), r.width(), r.height() );
}


Serial2Doc *Serial2View::getDocument() const
{
  Serial2App *theApp=(Serial2App *) parentWidget();

  return theApp->getDocument();
}

void Serial2View::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}
