/***************************************************************************
                          serial2view.h  -  description
                             -------------------
    begin                : Ut feb 18 14:21:20 CET 2003
    copyright            : (C) 2003 by Ondrej Krško
    email                : ondrej.krsko@zoznam.sk
 ***************************************************************************/

#ifndef SERIAL2VIEW_H
#define SERIAL2VIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

class Serial2Doc;

/** The Serial2View class provides the view widget for the Serial2App instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As Serial2View is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the Serial2App class to manipulate and display
 * the document structure provided by the Serial2Doc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class Serial2View : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    Serial2View(Serial2Doc* pDoc, QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~Serial2View();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a Serial2App instance as a parent
     * widget to get to the window document pointer by calling the Serial2App::getDocument() method.
     *
     * @see Serial2App#getDocument
     */
    Serial2Doc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);

  protected:
    virtual void mousePressEvent( QMouseEvent * );
    virtual void mouseReleaseEvent( QMouseEvent * );
    virtual void mouseMoveEvent( QMouseEvent * );
    virtual void paintEvent ( QPaintEvent *);

    Serial2Doc *doc;
    
  private:
    bool mousePressed;
    int oldX, oldY;
	
};

#endif // SERIAL2VIEW_H
